#ifndef FrameCPP_VERSION_3_FrEndOfFile_HH
#define FrameCPP_VERSION_3_FrEndOfFile_HH

#include "ldastoolsal/types.hh"

#include "framecpp/Version3/FrameSpec.hh"

#include "framecpp/Common/FrEndOfFile.hh"
#include "framecpp/Common/Verify.hh"

namespace FrameCPP
{
  namespace Version_3
  {
    class FrEndOfFile
      : public Common::FrEndOfFile
    {
    public:
      typedef INT_4U nFrames_type;
      typedef INT_4U nBytes_type;
      typedef INT_4U chkFlag_type;
      typedef INT_4U chkSum_type;

      FrEndOfFile( );
      virtual ~FrEndOfFile( );

      static const char* StructName( );

      static const Common::Description* StructDescription( );

      virtual Common::FrameSpec::size_type
      Bytes( const Common::StreamBase& Stream ) const;

      virtual FrEndOfFile* Clone( ) const;

      virtual FrEndOfFile* Create( istream_type& Stream ) const;

      virtual const char* ObjectStructName( ) const;

      virtual void Write( ostream_type& Stream ) const;

      /// \brief comparison operator
      bool operator==( const FrEndOfFile& RHS ) const;

      /// \brief comparison operator
      virtual bool operator==( const Common::FrameSpec::Object& Obj ) const;

      static const Common::FrameSpec::Info::frame_object_types s_object_id
      = Common::FrameSpec::Info::FSI_FR_END_OF_FILE;

      virtual nBytes_cmn_type NBytes( ) const;

      virtual FrEndOfFile::seekTOC_cmn_type SeekTOC( ) const;

      virtual void VerifyObject( Common::Verify& Verifier,
				 Common::IFrameStream& Stream ) const;

    protected:
      nFrames_type	m_nFrames;
      nBytes_type	m_nBytes;
      chkFlag_type	m_chkFlag;
      chkSum_type	m_chkSum;

      /// \brief Down grade an object
      virtual demote_ret_type demote( INT_2U Target,
				      demote_arg_type Obj,
				      istream_type* Stream ) const;

      /// \brief Upgrade an object
      virtual promote_ret_type promote( INT_2U Target,
					promote_arg_type Obj,
					istream_type* Stream ) const;

    private:
      using Common::FrameSpec::Object::Create;

      FrEndOfFile( istream_type& Source );

      //-----------------------------------------------------------------
      /// \brief Assign the contents of the instance
      ///
      /// \param[in] Source
      ///     An input stream from which to read information for
      ///     the instance.
      ///
      //-----------------------------------------------------------------
      virtual void assign( assign_stream_type& Stream );

      virtual chkSum_cmn_type Filter( const Common::IStream& Stream,
				      Common::CheckSum& Filt,
				      chkType_cmn_type& Type,
				      void* Buffer,
				      INT_8U Size ) const;

    }; // class - FrEndOfFile

    inline const char* FrEndOfFile::
    StructName( )
    {
      static const CHAR* class_name( "FrEndOfFile" );
      return class_name;
    }

    inline Common::FrEndOfFile::seekTOC_cmn_type FrEndOfFile::
    SeekTOC( ) const
    {
      return 0;
    }
  } // namespace - Version_3
} // namespace - FrameCPP

#endif /* FrameCPP_VERSION_3_FrEndOfFile_HH */
