#ifndef FrameCPP__VERSION_3__Specs_HH
#define FrameCPP__VERSION_3__Specs_HH

#include "ldastoolsal/types.hh"

#include "framecpp/Common/FrameSpec.hh"

#if defined(__cplusplus) && !defined(SWIG)
namespace FrameCPP
{
  //---------------------------------------------------------------------
  /// \brief Implementation of the version 3 specification
  ///
  /// This namespace includes classes and functions needed to implement
  /// the version 3 frame specification as described by LIGO-T970130-B-E
  /// dated October 12, 1997.
  //---------------------------------------------------------------------
  namespace Version_3
  {
    const CHAR_U DATA_FORMAT_VERSION( 3 );
    const CHAR_U LIBRARY_MINOR_VERSION( 11 );
  } // namespace - Version_3
} // namespace - FrameCPP
#endif /* defined(__cplusplus) && !defined(SWIG) */
#endif /* FrameCPP__VERSION_3__Specs_HH */
